javax.ws.rs.ext

## Interface Providers

- All Known Implementing Classes:
    ClientConfiguration, ResteasyProviderFactory, ThreadLocalResteasyProviderFactory

      public interface Providers

  An injectable interface providing runtime lookup of provider instances.
  Since:
    1.0
  Author:
    Paul Sandoz, Marc Hadley
  See Also:
    `Context`, `MessageBodyReader`, `MessageBodyWriter`, `ContextResolver`, `ExceptionMapper`

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `<T> ContextResolver<T>` | `getContextResolver(Class<T> contextType, MediaType mediaType)` Get a context resolver for a particular type of context and media type.
    `<T extends Throwable> ExceptionMapper<T>` | `getExceptionMapper(Class<T> type)` Get an exception mapping provider for a particular class of exception.
    `<T> MessageBodyReader<T>` | `getMessageBodyReader(Class<T> type, Type genericType, Annotation[] annotations, MediaType mediaType)` Get a message body reader that matches a set of criteria.
    `<T> MessageBodyWriter<T>` | `getMessageBodyWriter(Class<T> type, Type genericType, Annotation[] annotations, MediaType mediaType)` Get a message body writer that matches a set of criteria.

- - ### Method Detail

    - #### getMessageBodyReader

          <T> MessageBodyReader<T> getMessageBodyReader(Class<T> type,
                                                      Type genericType,
                                                      Annotation[] annotations,
                                                      MediaType mediaType)

      Get a message body reader that matches a set of criteria. The set of readers is first filtered by comparing the supplied value of `mediaType` with the value of each reader's `Consumes`, ensuring the supplied value of `type` is assignable to the generic type of the reader, and eliminating those that do not match. The list of matching readers is then ordered with those with the best matching values of `Consumes` (x/y > x/* > */*) sorted first. Finally, the `MessageBodyReader.isReadable(Class, Type, Annotation[], MediaType)` method is called on each reader in order using the supplied criteria and the first reader that returns `true` is selected and returned.
      Type Parameters:
        `T` - type of the the object that is to be read.
      Parameters:
        `type` - the class of the object that is to be read.
        `genericType` - the type of object to be produced. E.g. if the message body is to be converted into a method parameter, this will be the formal type of the method parameter as returned by `Class.getGenericParameterTypes`.
        `annotations` - an array of the annotations on the declaration of the artifact that will be initialized with the produced instance. E.g. if the message body is to be converted into a method parameter, this will be the annotations on that parameter returned by `Class.getParameterAnnotations`.
        `mediaType` - the media type of the data that will be read.
      Returns:
        a MessageBodyReader that matches the supplied criteria or `null` if none is found.

    - #### getMessageBodyWriter

          <T> MessageBodyWriter<T> getMessageBodyWriter(Class<T> type,
                                                      Type genericType,
                                                      Annotation[] annotations,
                                                      MediaType mediaType)

      Get a message body writer that matches a set of criteria. The set of writers is first filtered by comparing the supplied value of `mediaType` with the value of each writer's `Produces`, ensuring the supplied value of `type` is assignable to the generic type of the reader, and eliminating those that do not match. The list of matching writers is then ordered with those with the best matching values of `Produces` (x/y > x/* > */*) sorted first. Finally, the `MessageBodyWriter.isWriteable(Class, Type, Annotation[], MediaType)` method is called on each writer in order using the supplied criteria and the first writer that returns `true` is selected and returned.
      Type Parameters:
        `T` - type of the object that is to be written.
      Parameters:
        `type` - the class of the object that is to be written.
        `genericType` - the type of object to be written. E.g. if the message body is to be produced from a field, this will be the declared type of the field as returned by `Field.getGenericType`.
        `annotations` - an array of the annotations on the declaration of the artifact that will be written. E.g. if the message body is to be produced from a field, this will be the annotations on that field returned by `Field.getDeclaredAnnotations`.
        `mediaType` - the media type of the data that will be written.
      Returns:
        a MessageBodyReader that matches the supplied criteria or `null` if none is found.

    - #### getExceptionMapper

          <T extends Throwable> ExceptionMapper<T> getExceptionMapper(Class<T> type)

      Get an exception mapping provider for a particular class of exception. Returns the provider whose generic type is the nearest superclass of `type`.
      Type Parameters:
        `T` - type of the exception handled by the exception mapping provider.
      Parameters:
        `type` - the class of exception.
      Returns:
        an `ExceptionMapper` for the supplied type or `null` if none is found.

    - #### getContextResolver

          <T> ContextResolver<T> getContextResolver(Class<T> contextType,
                                                  MediaType mediaType)

      Get a context resolver for a particular type of context and media type. The set of resolvers is first filtered by comparing the supplied value of `mediaType` with the value of each resolver's `Produces`, ensuring the generic type of the context resolver is assignable to the supplied value of `contextType`, and eliminating those that do not match. If only one resolver matches the criteria then it is returned. If more than one resolver matches then the list of matching resolvers is ordered with those with the best matching values of `Produces` (x/y > x/* > */*) sorted first. A proxy is returned that delegates calls to `ContextResolver.getContext(java.lang.Class)` to each matching context resolver in order and returns the first non-null value it obtains or null if all matching context resolvers return null.
      Type Parameters:
        `T` - type of the context.
      Parameters:
        `contextType` - the class of context desired.
        `mediaType` - the media type of data for which a context is required.
      Returns:
        a matching context resolver instance or `null` if no matching context providers are found.

Copyright © 2014. All Rights Reserved.